/*
 * FlightCanvas.java
 *
 * Created on August 20, 2006, 2:44 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package flightgame;

import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import java.io.IOException;
/**
 *
 * @author dcsab. ANAND B
 */
public class FlightCanvas extends GameCanvas implements CommandListener, Runnable {

  Sprite mDot1;
      
  readWebHTTP r;
  /**Construct the displayable*/
  public FlightCanvas() {
    super(true);
    jbInit();
    createDotSprites();

    r = new readWebHTTP();
    Thread Tr = new Thread(r);
    Tr.start();

    Thread t = new Thread(this);
    t.start();
  }

  private void createDotSprites(){
   // Create the sprite.
   Image dotImage = null;
   try{
    dotImage = Image.createImage("/flightgame/dot1.png");
   }catch(IOException e) {}
   mDot1 = new Sprite(dotImage, 12, 12);
   mDot1.setPosition(getWidth()/2,getHeight()/2);
   mDot1.defineReferencePixel(6, 6);
   
  }

   
  /** Implementing RUN method - (GAME LOOP) **/
 public void run() {
   Graphics g = getGraphics();
   g.setColor(0,0,0);

   boolean mFlag = true;
   long startTime, timeDiff;
   
   while (mFlag) {
   
   startTime = System.currentTimeMillis();
       
    int keyStates = getKeyStates();
     if ( (keyStates & LEFT_PRESSED) != 0) {
       mDot1.move( -3, 0);
       r.setPos(mDot1.getX(), mDot1.getY());
     }
     else if ( (keyStates & RIGHT_PRESSED) != 0) {
       mDot1.move(3, 0);
       r.setPos(mDot1.getX(), mDot1.getY());
     }
     else if ( (keyStates & DOWN_PRESSED) != 0) {
       mDot1.move(0, 3);
       r.setPos(mDot1.getX(), mDot1.getY());
     } 
    else if ( (keyStates & UP_PRESSED) != 0) {
       mDot1.move(0, -3);
       r.setPos(mDot1.getX(), mDot1.getY());  
     }
    
  
     g.fillRect(0,0,getWidth(),getHeight());//Clear flight in previous position
     mDot1.paint(g);  //draw filght in new position
    
     flushGraphics();

     timeDiff = System.currentTimeMillis() - startTime;  //Gives TIME taken for executing (RENDERING) the GAME-LOOP once until FlushGraphics
     
     if (timeDiff < 40) {
      try { Thread.sleep(40-timeDiff); }     //1000ms/25frames = 40ms. [time per frame = 40ms]  
      catch (InterruptedException ie) {}     //if the loop is executed faster than 40ms, sleep for the remaining time.
     }
  }
  }

  /**Component initialization*/
  private void jbInit() {
    // set up this Displayable to listen to command events
    setCommandListener(this);
    // add the Exit command
    addCommand(new Command("Exit", Command.EXIT, 1));
  }

  /**Handle command events*/
  public void commandAction(Command command, Displayable displayable) {
    /** @todo Add command handling code */
    if (command.getCommandType() == Command.EXIT) {
       // stop the MIDlet
        r.closeConn();   //Close Socket Connection
        FlightMidlet.quitApp();
    }
  }

}
